// Generated by the WebObjects Wizard Tue Apr 11 15:02:26 US/Eastern 2000

import com.apple.yellow.foundation.*;
import com.apple.yellow.webobjects.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.eoaccess.*;
import java.math.BigDecimal;

public class InternetSearch extends WODirectAction {

    protected EOQualifier baseQualifier;
    protected static final String userInputString = "userString";
    
    protected int fetchLimit = 25;
    //protected String hrefAttribute;
    
    public InternetSearch(WORequest req) {
        super( req );
    }
    
    
    public WOActionResults searchAction(){

        EOQualifier theQual = null;

        WORequest theRequest = request();
        //System.out.println( theRequest.formValues() );
        //System.out.println( theRequest.formValueKeys() );

        String entityString = (String)(theRequest.formValueForKey("entityString"));
        String keyPath = (String)(theRequest.formValueForKey("keyPath"));
        String pageName = (String)(theRequest.formValueForKey("pageName"));
        String queryString = (String)(theRequest.formValueForKey("userString"));
        String SUMMARY_KEY = (String)(theRequest.formValueForKey("summaryString"));
        
        // get the request
        // look for the string that identifies the text form input (userInputString?)
        // get the string in the form
        // check for null
        //System.out.println( keyPath + pageName + queryString + entityString );

        // get a tokenizer for the string, defaults to whitespace as the token delimeter
        java.util.StringTokenizer tokenizer = new java.util.StringTokenizer(queryString);
        float queryWordCount = tokenizer.countTokens();
        System.out.println( queryWordCount );
        // optimization, if string has 1 word (no whitespace?) -> only build single qualifier
        if( queryWordCount == 0 )
            return null;

        NSMutableArray qualArray = new NSMutableArray();
        if( baseQualifier != null )
            qualArray.addObject( baseQualifier );

        StringBuffer qualStringBuffer;
        
        while( tokenizer.hasMoreTokens() )
        {
            qualStringBuffer = new StringBuffer(keyPath);
            qualStringBuffer.append(" caseInsensitiveLike '*");
            qualStringBuffer.append( tokenizer.nextToken() );
            qualStringBuffer.append( "*'" );
            try{
            qualArray.addObject( EOQualifier.qualifierWithQualifierFormat(qualStringBuffer.toString(), null) );
            }
            catch(Exception e){
                System.out.println( qualStringBuffer );
                System.out.println( e );
            }
            
        }
        theQual = new EOOrQualifier( qualArray );
        
        // else create new NSArray (for EOQualifiers to go into EOOrQualifier)
        // for each word in search string
            // EOQualifier.qualifierWithQualifierFormat( attributeString caseInsensitiveLike userInputString )
            // add qualifier to NSArray of EOQualifier
        // build EOOrQualifier
        // build FetchSpec with entityString and fetchLimit
        EOFetchSpecification fetchSpec = new EOFetchSpecification( entityString, theQual, null );
        fetchSpec.setFetchLimit( fetchLimit );
        // get NSArray of objectsWithFetchSpec
        NSArray results = session().defaultEditingContext().objectsWithFetchSpecification( fetchSpec );
        NSMutableArray fullResults = new NSMutableArray();
        // get valueForKey(property) on fetched objects as String
        for( int index=0; index < results.count(); index++)
        {
            EOEnterpriseObject theEO = (EOEnterpriseObject)results.objectAtIndex(index);
            String attr = (String) (theEO.valueForKeyPath(keyPath));
            java.util.StringTokenizer tok = new java.util.StringTokenizer( attr );
            float hitcount = 0;
            String aToken;
            //String upperQueryString = queryString.toUppreCase();
            while( tok.hasMoreTokens() )
            {
                aToken = tok.nextToken();
                if( queryString.indexOf( aToken ) > -1 )
                    hitcount++;

                System.out.println( aToken + " " + queryString + " " + hitcount + " " + (hitcount/queryWordCount)*100);
                
            }

            // need to generate a page as XML with links representing each found item
            // each link needs to represent itself uniquely in it's URL

            NSMutableDictionary eoData = new NSMutableDictionary();
            eoData.setObjectForKey( new Integer( (int) ((hitcount/queryWordCount)*100) ), "RELEVANCE" );
            eoData.setObjectForKey( attr, "LINK_STRING" );
            if( theEO.valueForKey(SUMMARY_KEY) != null )
                eoData.setObjectForKey( theEO.valueForKey(SUMMARY_KEY), "SUMMARY");                
            eoData.setObjectForKey( EOUtilities.
                                              primaryKeyForObject(theEO.editingContext(),
                                                                  theEO), "FOUND_OBJECT" );
            fullResults.addObject( eoData );
                                   
            
        }
        // for all resulting strings, indexOf(?) > -1, hitCount++
        // set NSArray element i (i=index of result string) to hitCount as string (Integer/Number?)
            // ( hitcount/wordCount=relevance)
        WOComponent nextPage = this.pageWithName("ResultComponent");
        // set response/result page NSArray
        nextPage.takeValueForKey(fullResults,"resultArray");
        nextPage.takeValueForKey(entityString,"entityString");
        nextPage.takeValueForKey(keyPath,"keyPath");
        nextPage.takeValueForKey(pageName,"pageName");
        //
        
        return nextPage;
        
    }

    public WOComponent resultAction() {
        WOComponent nextPage;
        NSMutableDictionary pkeyDict = new NSMutableDictionary();

        WORequest theRequest = request();
        String entityString = (String)(theRequest.formValueForKey("entityString"));
        String pageName = (String)(theRequest.formValueForKey("pageName"));

        
        NSDictionary pkeys = (NSDictionary)NSPropertyListSerialization.propertyListFromString((String)(theRequest.formValueForKey("eogid")));
        NSArray eokeys = pkeys.allKeys();
        EOEntity anEntity = EOUtilities.entityNamed( session().defaultEditingContext(), entityString );
        for( int index=0; index < eokeys.count(); index++ ) {
            EOAttribute attr = anEntity.attributeNamed(eokeys.objectAtIndex(index).toString());
            if ( attr.valueClassName().equals( "NSNumber" ) )
                pkeyDict.setObjectForKey( new Integer((String) (pkeys.objectForKey(attr.name()))), attr.name() );
            else if ( attr.valueClassName().equals( "NSDecimalNumber" ) )
                pkeyDict.setObjectForKey( new BigDecimal((String) (pkeys.objectForKey(attr.name()))), attr.name() );
            else 
                pkeyDict.setObjectForKey( (String) (pkeys.objectForKey(attr.name())), attr.name() );
        }

               
        nextPage = this.pageWithName(pageName);
        EOEnterpriseObject theEO = (EOEnterpriseObject) (EOUtilities.objectWithPrimaryKey(session().defaultEditingContext(), entityString, pkeyDict));

//        nextPage.takeValueForKey( pkeyDict, "primaryKeyDictionary" );
  //      nextPage.takeValueForKey( entityString, "entityString" );
        nextPage.takeValueForKey( theEO, "sherlockObject" );

        return nextPage;
    }

}
