// Generated by the WebObjects Wizard Tue Feb 29 13:20:13 US/Pacific 2000

import com.apple.yellow.foundation.*;
import com.apple.yellow.webobjects.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.eoaccess.*;


public class TestVideoPage extends WOComponent {
    protected Video randomVideo;
    protected String nextTarget = "myself";
    protected String artistAndTitle;
    
    protected String qtChapterString;
    protected EOQualifier videoQualifier = null;

    /** @TypeInfo Video */
    //protected NSMutableArray videos;
    //protected Video aVideo;

    /*
     look for movies matching criteria up to (const?, n?, all?)
     generate a page with (const?, n? all?) repetitions for ref to component with session id
     store songs in session
     when asked, component generates a SMIL doc that has a single ref, to the rtsp movie
     keep 2 lists,
        1 to randomly choose a song
        1 to keep sequential songs listed
     when playing a song, take it off of list 1 and add it to list2 (history)
     
     
    */
  /*  public TestVideoPage(){
        super();
        // assume this is the first time the session
        // is used to serve content so we need to put new movies into the session for next page to use
        // so we get content
        // discern what content we're fetching (Movies, MusicVideos, Audio, News)
        // for now only StoredAudioStreams (MP3!)
        // select Categories where Category.name in user selection
        // for now only trance/ambient
        EOEditingContext ec = session().defaultEditingContext();
        //NSDictionary catNames = new NSDictionary( new Object[] {"name","name","name","name"},
                                                  new Object[] {"trance/ambient","rock","techno","pop"});
//        EOQualifier qual = EOQualifier.qualifierWithQualifierFormat( "name = 'trance/ambient'",null );
       // EOQualifier qual = EOQualifier.qualifierToMatchAnyValue( catNames );
        //EOFetchSpecification fetchSpec = new EOFetchSpecification("AbstractCategory",qual,false);

        //session().setObjectForKey( new NSMutableArray( ec.objectsWithFetchSpecification( fetchSpec ) ), "MEDIA_ARRAY" );
        session().setObjectForKey( videos, "MEDIA_ARRAY" );
        // for each media type in a category
            // get all records
            // add to media array
        // bind # of media objects to the session

        
        
    }*/
    
    public void awake(){

        // we only get all videos once per session... new videos are only available to
        // sessions created after the video was input... news can't be this way...

        NSMutableArray videos = (NSMutableArray) session().objectForKey("VIDEO_ARRAY");
        
        if( videos == null )
        {
            EOEditingContext ec = session().defaultEditingContext();
            EOFetchSpecification fetchSpec = new EOFetchSpecification();
            fetchSpec.setIsDeep(false);
            fetchSpec.setEntityName("Video");

            videos = new NSMutableArray( ec.objectsWithFetchSpecification( fetchSpec ) );
            session().setObjectForKey( videos, "VIDEO_ARRAY" );
            
        }

        // now look for a random number to use as the index into the array of videos
        int anIndex = randomIndex( videos.count() );

        // we should never get into the situation where all songs are stale since we refresh
        // when we see the last fresh song

        // look for chance to play an ad
      /*  if( ((videos.count() % 5) == 0) && (session().objectForKey("PLAY_AD") != null) )
        {
            randomVideo = new Video();
            randomVideo.setQtUrl("rtsp://axiocranium.apple.com/true.mov");
            randomVideo.setTitle("Budweiser True ad");
            session().removeObjectForKey("PLAY_AD");
        }
        else
        {*/
            // delete the video from the array so we don't use it again
            randomVideo = (Video) videos.objectAtIndex( anIndex );
            videos.removeObjectAtIndex( anIndex );
            //session().setObjectForKey("PLAY_AD","PLAY_AD");
       // }

            
        // if the number of songs left in the array
        // (this is after the deletion from the list of the song we're about to play)
        // == the number 0, it's time to refresh the playlist... 

        if( videos.count() == 0 )
        {
            // deleting the videos from the session will force us to look in the db for songs
            // the next time we awake()
            session().removeObjectForKey("VIDEO_ARRAY");
        }

            
        
        System.out.println( videos.count() + " songs left, playing " + randomVideo.title() );
        
    }

    public String otherTagString(){
        StringBuffer buf = new StringBuffer(" ");

        // required namespace addition
        buf.append( "xmlns:qt=\"http://www.apple.com/quicktime/resources/smilextensions\" " );

        // turn on some QT player things
        buf.append( "qt:time-slider=\"true\" " );
        buf.append( "qt:autoplay=\"true\" " );

        // set the qt:Next param to this page with a full url
        // need to add the target param due to a QT4.1 player/plugin bug should be fixed in 4.1.1
        buf.append( "qt:next=\"<" );
        buf.append( context().completeURLWithRequestHandlerKey("wo","TestVideoPage.wo/" + session().sessionID(),"",false,0) );
        buf.append( ">T<");
        buf.append(nextTarget);
        buf.append( ">\"" );

        return buf.toString();

    }

    public void setVideoQualifier(EOQualifier q){
        videoQualifier = q;
        
    }

    
    
    public NSData artistAndTitle(){
        StringBuffer result = new StringBuffer();
        if(randomVideo != null)
        {
        result.append( randomVideo.artist().name() );
            result.append( "  " );
result.append( randomVideo.title() );

        }

        return new NSData( result.toString().getBytes() );
    }

    public Video randomVideo(){
        if( randomVideo == null )
            awake();
        return randomVideo;
    }

    public int randomIndex(int arrayLength){
        int aNum = (int) (Math.random() * 30000);
        aNum %= arrayLength;
        return aNum;
    }
    public NSData titleData() {
        return new NSData( randomVideo().title().getBytes() );
    }
    public void setTitleData(NSData newTitleData) {
        //titleData = newTitleData;
    }

    public String qtChapterString() {
        if( randomVideo != null )
            qtChapterString = randomVideo.title();
        return qtChapterString;
    }
    public void setQtChapterString(String newQtChapterString) {
        qtChapterString = newQtChapterString;
    }

}
