// Generated by the WebObjects Wizard Mon Mar 13 18:53:01 US/Pacific 2000

import com.apple.yellow.foundation.*;
import com.apple.yellow.webobjects.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.eoaccess.*;

public class VideoPage extends WOComponent {

    protected EOEnterpriseObject randomMovie;

	// url for where your movies are being streamed/served from 
	// eg. rtsp://qtss.yourdomain.com
    protected String MOVIE_SERVER_URL = "";
    
    protected EOEnterpriseObject sherlockObject;

    
    public EOEnterpriseObject getNextMovie(){

        // we only get all videos once per session... new videos are only available to
        // sessions created after the video was input... news can't be this way...
        // getting the videos from the session everytime is probably more expensive
        // than another if condition, but the number of times this returns null is large
        // compared to the number of calls where the sherlockObject is non-null
        NSMutableArray videos = (NSMutableArray) session().objectForKey("VIDEO_ARRAY");
        EOEnterpriseObject theVideo;

        System.out.println( context().request().method() );

        // for the case where a different link is chosen from Sherlock,
        // if someone set our sherlockObject, toss the previous song list
        if( sherlockObject != null ) {
            videos = new NSMutableArray( (NSArray) (sherlockObject.valueForKeyPath("videos")) );
            // save the sherlockObject in the session
            session().setObjectForKey(sherlockObject, "SHERLOCK_OBJECT");
            // it's saved so we can throw out the lcoal copy so multiple calls of this
            // method in this instance don't result in many fetches
            sherlockObject = null;
        }
        // if the videos array is missing from the session and the component,
        // get the sherlock object that *should* be in the session
        else if ( videos == null ) {
            sherlockObject = (EOEnterpriseObject) session().objectForKey("SHERLOCK_OBJECT");
            videos = new NSMutableArray( (NSArray) (sherlockObject.valueForKeyPath("videos")) );
            
        }


        // now look for a random number to use as the index into the array of videos
        int anIndex = randomIndex( videos.count() );

        // we should never get into the situation where all songs are stale since we refresh
        // when we see the last fresh song

        // delete the video from the array so we don't use it again
        theVideo = (EOEnterpriseObject) videos.objectAtIndex(anIndex);
        videos.removeObjectAtIndex(anIndex);
            
        // if the number of songs left in the array
        // (this is after the deletion from the list of the song we're about to play)
        // == the number 0, it's time to refresh the playlist... 

        if( videos.count() == 0 ) {
            // deleting the videos from the session will force us to look in the db for songs
            // the next time we awake()
            session().removeObjectForKey("VIDEO_ARRAY");
        }
        else {
            session().setObjectForKey( videos, "VIDEO_ARRAY" );

        }

        System.out.println( videos.count() + " songs left, playing " + theVideo.valueForKey("title") );

        return theVideo;

        
    }

    public String otherTagString(){
        StringBuffer buf = new StringBuffer(" ");

        // required namespace addition
        buf.append( "xmlns:qt=\"http://www.apple.com/quicktime/resources/smilextensions\" " );

        // turn on some QT player things
        buf.append( "qt:time-slider=\"true\" " );
        buf.append( "qt:autoplay=\"true\" " );

        // set the qt:Next param to this page with a full url
        // need to add the target param due to a QT4.1 player/plugin bug should be fixed in 4.1.1
        buf.append( "qt:next=\"" );
        buf.append( urlForNextMovie() );
        buf.append( "\"" );
        
        return buf.toString();
    }

    public String urlForNextMovie() {
        StringBuffer buf = new StringBuffer();

        //buf.append( context().completeURLWithRequestHandlerKey("wo","VideoPage.wo/" + session().sessionID(),"",false,0) );
        buf.append( application().cgiAdaptorURL() );
        buf.append( "/iSmilAdmin.woa/wo/VideoPage.wo/" );  // should be appname.woa/wo/pagename.wo
        buf.append( session().sessionID() );
        //buf.append( ">T<");
        //buf.append("?RonTV.sml");

        return buf.toString();

    }

    
    public NSData artistAndTitle(){
        StringBuffer result = new StringBuffer();

        result.append( randomMovie().valueForKeyPath("artist.name") );
        result.append( " * " );
        result.append( randomMovie().valueForKey("title") );

        return new NSData( result.toString().getBytes() );
    }

    public EOEnterpriseObject randomMovie(){
        if( randomMovie == null )
            randomMovie = getNextMovie();

        return randomMovie;
    }

    public String movieDuration() {
        String value="";

        try {
            value = randomMovie().valueForKey("duration").toString();            
        }
        catch(Exception e) {
            
        }

        return value;
    }
    
    public String movieURL() {
        String value = "";

        try{
            value += MOVIE_SERVER_URL;
            value = randomMovie().valueForKey("qtUrl").toString();
        }
        catch(Exception e) {
            
        }
        
        return value;
    }

    public int randomIndex(int arrayLength){
        int aNum = (int) (Math.random() * 30000);
        aNum %= arrayLength;
        return aNum;
    }




}
